// filerdr.cpp

// The FileReader class is used to read in information from ascii .ini files

#include <string.h>
//#include <mem.h>
#include <fcntl.h>
#include <io.h>
#include <stdlib.h>
#include "filerdr.h"

#include "main.h"

FileReader::FileReader(char* f)
{
	file = NULL;
	isValid=FALSE;
	int handle=open(f,O_RDONLY);
	if (handle==-1) return;
	filelen = filelength(handle);
	file = new char[filelen];
	read(handle, file, filelen);
	close(handle);
	titles=NULL;
	entries=NULL;
	noOfLines=0;
    isValid=TRUE;
}

BOOL FileReader::nextLine(char*& p)
{
	// locate next non-empty, non-comment line
	do {
		while(*p!=0 && *p!=10 && *p!=13) p++;
		while(*p==0 || *p==10 || *p==13) p++;
	} while(*p=='%');
	zeroTerm(p);
	if (strcmp("[end]",p)==0) return TRUE; else return FALSE;
}

void FileReader::zeroTerm(char* p)
{
	// search through whitespace for next significant character
	while(*p!=0 && *p!=10 && *p!=13) p++;
	*p=0;
}

BOOL FileReader::setSection(char* n)
{
	// move to named section of file

	char* s;
	if (*n=='[')
	{
		s=new char[strlen(n)+1];
		strcpy(s,n);
	}
	else
	{
		s=new char[strlen(n)+3];
		s[0]='[';
		strcpy(s+1,n);
		s[strlen(n)+1]=']';
		s[strlen(n)+2]=0;
	}

	BOOL eof=FALSE;
	char* p=file;
	zeroTerm(p);
	while(eof==FALSE)
	{
		if (strcmp(s,p)==0) break;
		eof=nextLine(p);
	}
	nextLine(p);
	char* temp=p;
	noOfLines=0;
	while(*temp!='[') {noOfLines++;nextLine(temp);}
	titles=new char*[noOfLines];
	entries=new char*[noOfLines];

	for(int c=0; c<noOfLines; c++)
	{
   	unsigned int l;
		for(l=0; l<=strlen(p); l++)
			if (*(p+l)=='=') break;
		if (l>strlen(p))
		{
			titles[c]=new char[strlen(p)+1];
			strcpy(titles[c],p);
			entries[c]=NULL;
		}
		else
		{
			titles[c]=new char[l+1];
			memcpy(titles[c],p,l);
			*(titles[c]+l)=0;
			if (*(p+l+1)==0) entries[c]=NULL;
			else
			{
				entries[c]=new char[strlen(p)-2];
				strcpy(entries[c],p+l+1);
			}
		}
		nextLine(p);
	}
	delete[] s;
	return TRUE;
}

FileReader::~FileReader()
{
	delete[] file; 
}

char* FileReader::readString(int t)
{
	// read specified line number

	return titles[t];
}

char* FileReader::readString(char* s)
{
	// read named setting ie. Speed = Normal

	int p;
	for(p=0; p<noOfLines; p++)
		if (strcmp(s,titles[p])==0) break;
	return (p==noOfLines) ? NULL : entries[p];
}

int FileReader::readInt(char* s)
{
	// convert read value to integer

	int p;
	for(p=0; p<noOfLines; p++)
		if (strcmp(s,titles[p])==0) break;
	return (p==noOfLines) ? 0 : atoi(entries[p]);
}

int FileReader::getLength()
{	return noOfLines;	}

