#ifndef DoneLinkedList

#include "main.h"

template <class Type>
class LinkedList
{
private:
	struct Link
	{
		Type item;
		Link* next;
	};
	Link* first,*current;
public:
	LinkedList()
	{	first=NULL; current=(Link*)1;	}

	~LinkedList()
	{
		if (first==NULL) return;
		Link* ptr=first,*temp;
		do	{
			temp=ptr->next;
			delete ptr;
			ptr=temp;
		}	while(ptr!=NULL);
	}

	void addItem(Type i)
	{
		LinkedList::Link* nl=new LinkedList::Link;
		nl->item=i;
		nl->next=first;
		first=nl;
	}

	Type getNext()
	{
		if (first==NULL || current==NULL) return NULL;
		if (current==(Link*)1) current=first;
		Type result=current->item;
		current=current->next;
		return result;
	}

	void reset()
	{	current=first;	}

	void deleteItem(Type i)
	{
		if (first==NULL)
			{showMessage("LinkedList: Attempt to delete from empty list");return;}
		if (first->item==i)
		{
			Link* temp=first->next;
			delete first;
			first=temp;
			return;
		}
		Link* ptr=first;
		while(ptr->next->item!=i)
		{
			ptr=ptr->next;
			if (ptr->next==NULL)
				{showMessage("LinkedList: Attempt to delete non-existant item");return;}
		}
		Link* temp=ptr->next->next;
		delete ptr->next;
		ptr->next=temp;
	}
};
#endif
#define DoneLinkedList

