#ifndef SpriteDone

#include "main.h"
#include "LinkList.h"
#include <io.h>
#include <fcntl.h>

#ifndef DoneWindows
typedef unsigned long DWORD;
typedef unsigned char BYTE;
#endif

#ifndef DoneDDraw
/*struct IDirectDraw;
struct IDirectDrawSurface;
struct IDirectDrawPalette;

typedef struct IDirectDraw                       *LPDIRECTDRAW;
typedef struct IDirectDraw2                      *LPDIRECTDRAW2;
typedef struct IDirectDrawSurface                *LPDIRECTDRAWSURFACE;
typedef struct IDirectDrawSurface2               *LPDIRECTDRAWSURFACE2;

typedef struct IDirectDrawPalette                *LPDIRECTDRAWPALETTE;

typedef struct _DDCOLORKEY
{
	DWORD       dwColorSpaceLowValue;   // low boundary of color space that is to
										// be treated as Color Key, inclusive
	DWORD       dwColorSpaceHighValue;  // high boundary of color space that is
										// to be treated as Color Key, inclusive
} DDCOLORKEY;

typedef DDCOLORKEY * LPDDCOLORKEY;*/
#include <ddraw.h>
#define DoneDDraw
#endif

class Sprite
{
public:
	enum SPRITECOL {YELLOW,CYAN,MAGENTA,GREEN,BLUE};
private:
	static LinkedList<Sprite*> list;
	int width,height;
	IDirectDrawSurface* pdds;
	BOOL mask;
	BOOL flipped;
	int magnification;
	int pitch;
	unsigned char* pSurface;
	BOOL bLocked;
	char* filename;
	static LPDIRECTDRAW lpDD;
	static int scrnWidth;
	static int scrnHeight;
	static LPDIRECTDRAWSURFACE lpDDSBack;
	static LPDIRECTDRAWSURFACE lpDDSPrimary;
	static LPDDCOLORKEY lpDDColorKey;
	static LPDIRECTDRAWPALETTE pDDpal;
	static int count;
	static unsigned char* pFont;
	static BOOL surfacesLost;
	static BOOL fullScreen;
	static LPDIRECTDRAWCLIPPER lpDDClipper;
	static HWND hwnd;
	static BOOL noRestore; // used to check sufraces are not reloaded twice on size change
	static BOOL hicolour;

	static BOOL createSurfaces();

public:
	Sprite();
	~Sprite();
	static void closeDown();
//	static void setup(LPDIRECTDRAW,int,int,LPDIRECTDRAWSURFACE,
//						LPDIRECTDRAWSURFACE,char*,LPDDCOLORKEY);
	static BOOL setup(void*,BOOL,int,int); // really a HWND
	static BOOL restoreAll();
	static void flipScreens();
	static int getScrnWidth();
	static int getScrnHeight();
	static LPDIRECTDRAW getDD() { return Sprite::lpDD;	}
	static BOOL setSize(BOOL, int, int);
	static BOOL loseSurfaces();
	static void cls();
    static void report();
	BOOL load(char*);
	BOOL load(char*,int); // load and magnify
	BOOL load(char*,int,int); // load and scale to given size
	void setMask();
	void clearMask();
	void flip();
	void colourize(SPRITECOL, Sprite*, int x, int y, int magnify);
	BOOL restore();
	void blacken();
	void setSize(int,int);
	BOOL draw(int x,int y,float size);
	BOOL draw(int x,int y);
	BOOL drawFlip(int x, int y);
	BOOL draw(Sprite* target, int x, int y); // blit into 'target' Sprite
	BOOL draw(Sprite* target,int x, int y, RECT& src);
    BOOL draw(int x, int y, RECT& src); // only draw RECT of source
	void drawBlack(int,int);
	int getWidth() { return width; }
	int getHeight() { return height; }
	void rotate(Sprite*,int);
	BYTE* lock();
	void unlock();
	int getPitch();
	void drawText(char*,int,int);
	BOOL drawText(int,int,int);
	BOOL drawText(char*,int,int,int);
	BOOL drawText(float,int,int);
	BOOL drawLine(int,int,int,int,int);
	BOOL drawRect(int,int,int,int,int);
	BOOL drawFillRect(int,int,int,int,int);
	static BOOL getSurfacesLost() {return Sprite::surfacesLost;}
	static void setSurfacesLost(BOOL b) {Sprite::surfacesLost=b;}
	static void showMode();
	static setNoRestore(BOOL r) {Sprite::noRestore=r;}
	static setHicolour(BOOL h) {Sprite::hicolour=h;}
};
#endif
#define SpriteDone

